## orthanc-postgresql 1.2

=== CMakeLists.txt ===
# Orthanc - A Lightweight, RESTful DICOM Store
# Copyright (C) 2012-2015 Sebastien Jodogne, Medical Physics
# Department, University Hospital of Liege, Belgium
#
# This program is free software: you can redistribute it and/or
# modify it under the terms of the GNU Affero General Public License
# as published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.


cmake_minimum_required(VERSION 2.8)

project(OrthancPostgreSQL)

set(ORTHANC_POSTGRESQL_VERSION "1.2")


# Parameters of the build
set(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
set(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")
set(BUILD_UNIT_TESTS ON CACHE BOOL "Build UnitTests")

# Advanced parameters to fine-tune linking against system libraries
set(USE_SYSTEM_JSONCPP ON CACHE BOOL "Use the system version of JsonCpp")
set(USE_SYSTEM_BOOST ON CACHE BOOL "Use the system version of Boost")
set(USE_SYSTEM_GOOGLE_TEST ON CACHE BOOL "Use the system version of Google Test")
set(USE_SYSTEM_LIBPQ ON CACHE BOOL "Use the system version of the PostgreSQL client library")

# Distribution-specific settings
set(USE_GTEST_DEBIAN_SOURCE_PACKAGE OFF CACHE BOOL "Use the sources of Google Test shipped with libgtest-dev (Debian only)")
mark_as_advanced(USE_GTEST_DEBIAN_SOURCE_PACKAGE)

set(ORTHANC_ROOT ${CMAKE_SOURCE_DIR}/Orthanc)
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(FindPythonInterp)
include(${ORTHANC_ROOT}/Resources/CMake/Compiler.cmake)
include(${ORTHANC_ROOT}/Resources/CMake/AutoGeneratedCode.cmake)
include(${ORTHANC_ROOT}/Resources/CMake/DownloadPackage.cmake)
include(${ORTHANC_ROOT}/Resources/CMake/BoostConfiguration.cmake)
include(${ORTHANC_ROOT}/Resources/CMake/JsonCppConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/PostgreSQLConfiguration.cmake)

if (BUILD_UNIT_TESTS)
  include(${ORTHANC_ROOT}/Resources/CMake/GoogleTestConfiguration.cmake)
endif()


if (STATIC_BUILD)
  include_directories(${ORTHANC_ROOT}/Sdk-0.9.1)
else ()
  CHECK_INCLUDE_FILE_CXX(orthanc/OrthancCppDatabasePlugin.h HAVE_ORTHANC_H)
  if (NOT HAVE_ORTHANC_H)
    message(FATAL_ERROR "Please install the headers of the Orthanc plugins SDK")
  endif()
endif()



if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  link_libraries(secur32)

  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
    ${ORTHANC_POSTGRESQL_VERSION} "PostgreSQL storage plugin" OrthancPostgreSQLStorage.dll
    "PostgreSQL as a database back-end to Orthanc (storage area)"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/StorageVersion.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
    ${ORTHANC_POSTGRESQL_VERSION} "PostgreSQL index plugin" OrthancPostgreSQLIndex.dll
    "PostgreSQL as a database back-end to Orthanc (index area)"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/IndexVersion.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  set(INDEX_RESOURCES ${AUTOGENERATED_DIR}/IndexVersion.rc)
  set(STORAGE_RESOURCES ${AUTOGENERATED_DIR}/StorageVersion.rc)
endif()

if (CMAKE_COMPILER_IS_GNUCXX)
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--version-script=${CMAKE_SOURCE_DIR}/Orthanc/Plugins/Samples/Common/VersionScript.map -Wl,--no-undefined")
endif()



# Embed the SQL files into the binaries
EmbedResources(
  --system-exception 
  --namespace=OrthancPlugins
  POSTGRESQL_PREPARE ${CMAKE_CURRENT_SOURCE_DIR}/IndexPlugin/PostgreSQLPrepare.sql
  )

set(CORE_SOURCES
  ${CMAKE_SOURCE_DIR}/Core/PostgreSQLConnection.cpp
  ${CMAKE_SOURCE_DIR}/Core/PostgreSQLLargeObject.cpp
  ${CMAKE_SOURCE_DIR}/Core/PostgreSQLResult.cpp
  ${CMAKE_SOURCE_DIR}/Core/PostgreSQLStatement.cpp
  ${CMAKE_SOURCE_DIR}/Core/PostgreSQLTransaction.cpp
  ${CMAKE_SOURCE_DIR}/Core/Configuration.cpp
  ${CMAKE_SOURCE_DIR}/Core/GlobalProperties.cpp

  ${LIBPQ_SOURCES}
  ${BOOST_SOURCES}
  ${JSONCPP_SOURCES}
  )

add_library(OrthancPostgreSQLStorage
  SHARED
  ${CORE_SOURCES}
  ${CMAKE_SOURCE_DIR}/StoragePlugin/PostgreSQLStorageArea.cpp
  ${CMAKE_SOURCE_DIR}/StoragePlugin/Plugin.cpp
  ${STORAGE_RESOURCES}
  )

add_library(OrthancPostgreSQLIndex
  SHARED
  ${CORE_SOURCES}
  ${AUTOGENERATED_SOURCES}
  ${CMAKE_SOURCE_DIR}/IndexPlugin/PostgreSQLWrapper.cpp
  ${CMAKE_SOURCE_DIR}/IndexPlugin/Plugin.cpp
  ${INDEX_RESOURCES}
  )


message("Setting the version of the libraries to ${ORTHANC_POSTGRESQL_VERSION}")

add_definitions(-DORTHANC_POSTGRESQL_VERSION="${ORTHANC_POSTGRESQL_VERSION}")

set_target_properties(OrthancPostgreSQLStorage PROPERTIES 
  VERSION ${ORTHANC_POSTGRESQL_VERSION} 
  SOVERSION ${ORTHANC_POSTGRESQL_VERSION}
  )

set_target_properties(OrthancPostgreSQLIndex PROPERTIES 
  VERSION ${ORTHANC_POSTGRESQL_VERSION} 
  SOVERSION ${ORTHANC_POSTGRESQL_VERSION}
  )

install(
  TARGETS OrthancPostgreSQLStorage OrthancPostgreSQLIndex
  RUNTIME DESTINATION lib    # Destination for Windows
  LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
  )

if (BUILD_UNIT_TESTS)
  add_executable(UnitTests
    ${CORE_SOURCES}
    ${GTEST_SOURCES}
    ${AUTOGENERATED_SOURCES}
    ${CMAKE_SOURCE_DIR}/IndexPlugin/PostgreSQLWrapper.cpp
    ${CMAKE_SOURCE_DIR}/StoragePlugin/PostgreSQLStorageArea.cpp
    ${CMAKE_SOURCE_DIR}/UnitTestsSources/UnitTestsMain.cpp
    ${CMAKE_SOURCE_DIR}/UnitTestsSources/PostgreSQLTests.cpp
    ${CMAKE_SOURCE_DIR}/UnitTestsSources/PostgreSQLWrapperTests.cpp
    )
endif()

=== debian/changelog ===
orthanc-postgresql (1.2-1) unstable; urgency=medium

  [ Sebastien Jodogne ]
  * New upstream version

  [ Karsten Hilbert ]
  * Enhancements for README.Debian

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 03 Aug 2015 09:23:28 +0200

orthanc-postgresql (1.1-1) unstable; urgency=medium

  * New upstream version.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 03 Jul 2015 11:48:52 +0200

orthanc-postgresql (1.0-1) unstable; urgency=low

  * Initial release. (Closes: #779327)

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 27 Feb 2015 21:29:38 +0100

=== debian/control ===
Source: orthanc-postgresql
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Standards-Version: 3.9.6
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9),
               libboost-all-dev,
               libgtest-dev (>= 1.6.0),
               libjsoncpp-dev,
               libpq-dev,
               orthanc-dev (>= 0.9.1),
               postgresql-server-dev-all,
               unzip,
               uuid-dev
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/orthanc-postgresql/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/orthanc-postgresql/trunk/
Homepage: http://www.orthanc-server.com/static.php?page=postgresql

Package: orthanc-postgresql
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, orthanc (>= 0.9.1)
Suggests: postgresql
Description: Plugins to use PostgreSQL as a database back-end to Orthanc
 Orthanc PostgreSQL is a set of two plugins to Orthanc, a lightweight,
 RESTful Vendor Neutral Archive for medical imaging. These plugins
 override the default SQLite engine of Orthanc with a PostgreSQL
 back-end. They bring scalability to Orthanc, making it
 enterprise-ready.

=== debian/rules ===
#!/usr/bin/make -f

export JAVASCRIPT_LIBS := Build/javascript-libs
export DEBIAN_VERSION := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
export UPSTREAM_VERSION := $(shell echo "$(DEBIAN_VERSION)" | cut -d '-' -f 1)
export TARGET_INDEX := libOrthancPostgreSQLIndex.so
export TARGET_STORAGE := libOrthancPostgreSQLStorage.so

%:
	dh $@ --parallel --builddirectory=Build

CMAKE_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DSTATIC_BUILD:BOOL=OFF \
        -DUSE_GTEST_DEBIAN_SOURCE_PACKAGE:BOOL=ON \
	-DCMAKE_BUILD_TYPE=""   # The build type must be left empty, see #711515

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_install:
	cp Build/${TARGET_INDEX} Build/${TARGET_INDEX}.${UPSTREAM_VERSION}
	cp Build/${TARGET_STORAGE} Build/${TARGET_STORAGE}.${UPSTREAM_VERSION}

	dh_install Build/${TARGET_INDEX}.${UPSTREAM_VERSION} usr/lib
	dh_install Build/${TARGET_STORAGE}.${UPSTREAM_VERSION} usr/lib

override_dh_link:
	dh_link usr/lib/${TARGET_INDEX}.${UPSTREAM_VERSION} usr/share/orthanc/plugins/${TARGET_INDEX}
	dh_link usr/lib/${TARGET_STORAGE}.${UPSTREAM_VERSION} usr/share/orthanc/plugins/${TARGET_STORAGE}

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

get-orig-source:
	uscan --verbose --force-download --repack --compression xz

## orthanc-postgresql 2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 project(OrthancPostgreSQL)
 
-set(ORTHANC_POSTGRESQL_VERSION "1.2")
+set(ORTHANC_POSTGRESQL_VERSION "2.0")
 
 
 # Parameters of the build
@@ -33,6 +33,7 @@
 set(USE_SYSTEM_BOOST ON CACHE BOOL "Use the system version of Boost")
 set(USE_SYSTEM_GOOGLE_TEST ON CACHE BOOL "Use the system version of Google Test")
 set(USE_SYSTEM_LIBPQ ON CACHE BOOL "Use the system version of the PostgreSQL client library")
+set(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")
 
 # Distribution-specific settings
 set(USE_GTEST_DEBIAN_SOURCE_PACKAGE OFF CACHE BOOL "Use the sources of Google Test shipped with libgtest-dev (Debian only)")
@@ -55,8 +56,8 @@
 endif()
 
 
-if (STATIC_BUILD)
-  include_directories(${ORTHANC_ROOT}/Sdk-0.9.1)
+if (STATIC_BUILD OR NOT USE_SYSTEM_ORTHANC_SDK)
+  include_directories(${ORTHANC_ROOT}/Sdk-0.9.5)
 else ()
   CHECK_INCLUDE_FILE_CXX(orthanc/OrthancCppDatabasePlugin.h HAVE_ORTHANC_H)
   if (NOT HAVE_ORTHANC_H)
@@ -99,10 +100,6 @@
   set(STORAGE_RESOURCES ${AUTOGENERATED_DIR}/StorageVersion.rc)
 endif()
 
-if (CMAKE_COMPILER_IS_GNUCXX)
-  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--version-script=${CMAKE_SOURCE_DIR}/Orthanc/Plugins/Samples/Common/VersionScript.map -Wl,--no-undefined")
-endif()
-
 
 
 # Embed the SQL files into the binaries
@@ -110,6 +107,8 @@
   --system-exception 
   --namespace=OrthancPlugins
   POSTGRESQL_PREPARE ${CMAKE_CURRENT_SOURCE_DIR}/IndexPlugin/PostgreSQLPrepare.sql
+  POSTGRESQL_PREPARE_V5 ${CMAKE_CURRENT_SOURCE_DIR}/IndexPlugin/PostgreSQLVersion5.sql
+  POSTGRESQL_PREPARE_V6 ${CMAKE_CURRENT_SOURCE_DIR}/IndexPlugin/PostgreSQLVersion6.sql
   )
 
 set(CORE_SOURCES

=== debian/changelog ===
orthanc-postgresql (2.0-5) unstable; urgency=medium

  * Team upload
  * Moved packaging from SVN to Git
  * Removed myself from Uploaders
  * debhelper 10

 -- Andreas Tille <tille@debian.org>  Thu, 30 Nov 2017 15:45:17 +0100

orthanc-postgresql (2.0-4) unstable; urgency=medium

  * Fix to find PostgreSQL 10 dev headers. Closes: #878565

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 16 Oct 2017 09:20:09 +0200

orthanc-postgresql (2.0-3) unstable; urgency=medium

  * Fix to find PostgreSQL 9.6 dev headers. Closes: #839309

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 03 Oct 2016 10:45:00 +0200

orthanc-postgresql (2.0-2) unstable; urgency=medium

  * Fix to find PostgreSQL 9.5 dev headers. Closes: #811141
  * Add hardening flags

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 29 Jun 2016 17:02:36 +0200

orthanc-postgresql (2.0-1) unstable; urgency=medium

  * New upstream version.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 10 Dec 2015 15:13:49 +0100

orthanc-postgresql (1.3-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 07 Oct 2015 11:41:47 +0200

=== debian/control ===
Source: orthanc-postgresql
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               libboost-all-dev,
               libgtest-dev,
               libjsoncpp-dev,
               libpq-dev,
               orthanc-dev,
               postgresql-server-dev-all,
               unzip,
               uuid-dev
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/orthanc-postgresql.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/orthanc-postgresql.git
Homepage: https://www.orthanc-server.com/static.php?page=postgresql

Package: orthanc-postgresql
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         orthanc (>= 0.9.5)
Suggests: postgresql
Description: Plugins to use PostgreSQL as a database back-end to Orthanc
 Orthanc PostgreSQL is a set of two plugins to Orthanc, a lightweight,
 RESTful Vendor Neutral Archive for medical imaging. These plugins
 override the default SQLite engine of Orthanc with a PostgreSQL
 back-end. They bring scalability to Orthanc, making it
 enterprise-ready.

=== debian/rules ===
--- 
+++ 
@@ -1,18 +1,22 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/pkg-info.mk   # To access the "DEB_VERSION" variable
+
 export JAVASCRIPT_LIBS := Build/javascript-libs
-export DEBIAN_VERSION := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
-export UPSTREAM_VERSION := $(shell echo "$(DEBIAN_VERSION)" | cut -d '-' -f 1)
+export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '+' -f 1)
 export TARGET_INDEX := libOrthancPostgreSQLIndex.so
 export TARGET_STORAGE := libOrthancPostgreSQLStorage.so
 
+export DEB_BUILD_MAINT_OPTIONS := hardening=+all
+
 %:
-	dh $@ --parallel --builddirectory=Build
+	dh $@ --builddirectory=Build
 
 CMAKE_EXTRA_FLAGS += \
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
 	-DSTATIC_BUILD:BOOL=OFF \
         -DUSE_GTEST_DEBIAN_SOURCE_PACKAGE:BOOL=ON \
+	-DDEB_VERSION=$(DEB_VERSION) \
 	-DCMAKE_BUILD_TYPE=""   # The build type must be left empty, see #711515
 
 override_dh_auto_configure:

=== debian/watch ===
version=3
opts="downloadurlmangle=s/\/browse\.php\?path=//g" \
https://www.orthanc-server.com/browse.php?path=/plugin-postgresql downloads/get\.php\?path=/plugin-postgresql/OrthancPostgreSQL-(\d\S*)\.tar\.gz

## orthanc-postgresql 2.2

=== PostgreSQL/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(OrthancPostgreSQL)

set(ORTHANC_PLUGIN_VERSION "2.2")

if (ORTHANC_PLUGIN_VERSION STREQUAL "mainline")
  set(ORTHANC_FRAMEWORK_VERSION "mainline")
  set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
else()
  set(ORTHANC_FRAMEWORK_VERSION "1.4.0")
  set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
endif()

include(${CMAKE_SOURCE_DIR}/../Resources/CMake/DatabasesPluginParameters.cmake)

set(ENABLE_POSTGRESQL_BACKEND ON)
  
include(${CMAKE_SOURCE_DIR}/../Resources/CMake/DatabasesPluginConfiguration.cmake)


if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
    ${ORTHANC_PLUGIN_VERSION} "PostgreSQL storage area plugin" OrthancPostgreSQLStorage.dll
    "PostgreSQL as a database back-end to Orthanc (storage area)"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/StorageVersion.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  execute_process(
    COMMAND 
    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
    ${ORTHANC_PLUGIN_VERSION} "PostgreSQL index plugin" OrthancPostgreSQLIndex.dll
    "PostgreSQL as a database back-end to Orthanc (index)"
    ERROR_VARIABLE Failure
    OUTPUT_FILE ${AUTOGENERATED_DIR}/IndexVersion.rc
    )

  if (Failure)
    message(FATAL_ERROR "Error while computing the version information: ${Failure}")
  endif()

  set(INDEX_RESOURCES ${AUTOGENERATED_DIR}/IndexVersion.rc)
  set(STORAGE_RESOURCES ${AUTOGENERATED_DIR}/StorageVersion.rc)
endif()


EmbedResources(
  POSTGRESQL_PREPARE_INDEX ${CMAKE_SOURCE_DIR}/Plugins/PrepareIndex.sql
  )

add_library(OrthancPostgreSQLIndex SHARED
  ${INDEX_RESOURCES}
  ${ORTHANC_DATABASES_ROOT}/Framework/Plugins/PluginInitialization.cpp
  Plugins/IndexPlugin.cpp
  Plugins/PostgreSQLIndex.cpp

  ${DATABASES_SOURCES}
  ${AUTOGENERATED_SOURCES}
  )

add_library(OrthancPostgreSQLStorage SHARED
  ${ORTHANC_DATABASES_ROOT}/Framework/Plugins/PluginInitialization.cpp
  ${STORAGE_RESOURCES}
  Plugins/PostgreSQLStorageArea.cpp
  Plugins/StoragePlugin.cpp

  ${DATABASES_SOURCES}
  ${AUTOGENERATED_SOURCES}
  )

message("Setting the version of the libraries to ${ORTHANC_PLUGIN_VERSION}")

add_definitions(
  -DORTHANC_PLUGIN_VERSION="${ORTHANC_PLUGIN_VERSION}"
  -DHAS_ORTHANC_EXCEPTION=1
  )

set_target_properties(OrthancPostgreSQLStorage PROPERTIES 
  VERSION ${ORTHANC_PLUGIN_VERSION} 
  SOVERSION ${ORTHANC_PLUGIN_VERSION}
  COMPILE_FLAGS -DORTHANC_ENABLE_LOGGING_PLUGIN=1
  )

set_target_properties(OrthancPostgreSQLIndex PROPERTIES 
  VERSION ${ORTHANC_PLUGIN_VERSION} 
  SOVERSION ${ORTHANC_PLUGIN_VERSION}
  COMPILE_FLAGS -DORTHANC_ENABLE_LOGGING_PLUGIN=1
  )

install(
  TARGETS OrthancPostgreSQLIndex OrthancPostgreSQLStorage
  RUNTIME DESTINATION lib    # Destination for Windows
  LIBRARY DESTINATION share/orthanc/plugins    # Destination for Linux
  )


add_executable(UnitTests
  Plugins/PostgreSQLIndex.cpp
  Plugins/PostgreSQLStorageArea.cpp
  UnitTests/PostgreSQLTests.cpp
  UnitTests/UnitTestsMain.cpp
  ${DATABASES_SOURCES}
  ${GOOGLE_TEST_SOURCES}
  ${AUTOGENERATED_SOURCES}
  )

target_link_libraries(UnitTests ${GOOGLE_TEST_LIBRARIES})
set_target_properties(UnitTests PROPERTIES
  COMPILE_FLAGS -DORTHANC_ENABLE_LOGGING_PLUGIN=0
  )

=== debian/changelog ===
orthanc-postgresql (2.2-1) unstable; urgency=medium

  * New upstream version
  * Updated d/upstream/metadata with new reference paper about Orthanc

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 17 Jul 2018 18:10:20 +0200

orthanc-postgresql (2.1-2) unstable; urgency=medium

  * Set -DNDEBUG to disable assertion checking
  * Set -DCMAKE_BUILD_TYPE=None

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 27 Apr 2018 14:21:02 +0200

orthanc-postgresql (2.1-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 20 Apr 2018 17:31:27 +0200

=== debian/control ===
--- 
+++ 
@@ -13,9 +13,9 @@
                postgresql-server-dev-all,
                unzip,
                uuid-dev
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/orthanc-postgresql.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/orthanc-postgresql.git
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/med-team/orthanc-postgresql
+Vcs-Git: https://salsa.debian.org/med-team/orthanc-postgresql.git
 Homepage: https://www.orthanc-server.com/static.php?page=postgresql
 
 Package: orthanc-postgresql

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk   # To access the "DEB_VERSION" variable

export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '+' -f 1)
export TARGET_INDEX := libOrthancPostgreSQLIndex.so
export TARGET_STORAGE := libOrthancPostgreSQLStorage.so

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# Disable assert() checking from upstream project, for best performance
# https://lists.debian.org/debian-med/2018/04/msg00132.html
export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ --builddirectory=Build

CMAKE_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DSTATIC_BUILD:BOOL=OFF \
        -DUSE_GOOGLE_TEST_DEBIAN_PACKAGE:BOOL=ON \
        -DDEB_VERSION=$(DEB_VERSION) \
        -DCMAKE_BUILD_TYPE=None  # The build type must be set to None, see #711515

override_dh_auto_configure:
        # Put 3rd party packages where the cmake build system expects them
	mkdir -p PostgreSQL/ThirdPartyDownloads
	( cd PostgreSQL/ThirdPartyDownloads && \
	  cp ../../debian/ThirdPartyDownloads/Orthanc-1.4.0.tar.gz . )

	mkdir Build
	dh_auto_configure --builddirectory=Build \
			  --sourcedirectory=PostgreSQL \
			  -- $(CMAKE_EXTRA_FLAGS)

override_dh_clean:
	rm -rf PostgreSQL/ThirdPartyDownloads/
	dh_clean

override_dh_auto_install:
	cp Build/${TARGET_INDEX} Build/${TARGET_INDEX}.${UPSTREAM_VERSION}
	cp Build/${TARGET_STORAGE} Build/${TARGET_STORAGE}.${UPSTREAM_VERSION}

	dh_install Build/${TARGET_INDEX}.${UPSTREAM_VERSION} usr/lib
	dh_install Build/${TARGET_STORAGE}.${UPSTREAM_VERSION} usr/lib

override_dh_link:
	dh_link usr/lib/${TARGET_INDEX}.${UPSTREAM_VERSION} usr/share/orthanc/plugins/${TARGET_INDEX}
	dh_link usr/lib/${TARGET_STORAGE}.${UPSTREAM_VERSION} usr/share/orthanc/plugins/${TARGET_STORAGE}

override_dh_installchangelogs:
	dh_installchangelogs -k PostgreSQL/NEWS

## orthanc-postgresql 3.1

=== PostgreSQL/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPostgreSQL)
 
-set(ORTHANC_PLUGIN_VERSION "2.2")
+set(ORTHANC_PLUGIN_VERSION "3.1")
 
 if (ORTHANC_PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_VERSION "1.4.0")
+  set(ORTHANC_FRAMEWORK_VERSION "1.5.4")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
 
@@ -51,7 +51,11 @@
 
 
 EmbedResources(
-  POSTGRESQL_PREPARE_INDEX ${CMAKE_SOURCE_DIR}/Plugins/PrepareIndex.sql
+  POSTGRESQL_PREPARE_INDEX          ${CMAKE_SOURCE_DIR}/Plugins/PrepareIndex.sql
+  POSTGRESQL_CREATE_INSTANCE        ${CMAKE_SOURCE_DIR}/Plugins/CreateInstance.sql
+  POSTGRESQL_FAST_TOTAL_SIZE        ${CMAKE_SOURCE_DIR}/Plugins/FastTotalSize.sql
+  POSTGRESQL_FAST_COUNT_RESOURCES   ${CMAKE_SOURCE_DIR}/Plugins/FastCountResources.sql
+  POSTGRESQL_GET_LAST_CHANGE_INDEX  ${CMAKE_SOURCE_DIR}/Plugins/GetLastChangeIndex.sql
   )
 
 add_library(OrthancPostgreSQLIndex SHARED
@@ -78,7 +82,6 @@
 
 add_definitions(
   -DORTHANC_PLUGIN_VERSION="${ORTHANC_PLUGIN_VERSION}"
-  -DHAS_ORTHANC_EXCEPTION=1
   )
 
 set_target_properties(OrthancPostgreSQLStorage PROPERTIES

=== debian/changelog ===
orthanc-postgresql (3.1-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sat, 09 Feb 2019 11:27:38 +0100

orthanc-postgresql (3.0-2) unstable; urgency=medium

  * Removed $(DEB_VERSION) from SOVERSION.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 28 Jan 2019 12:58:36 +0100

orthanc-postgresql (3.0-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 22 Jan 2019 09:48:21 +0100

orthanc-postgresql (2.2-4) unstable; urgency=medium

  * Fix missing dependency on zlib1g-dev. Closes: #916954

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 21 Dec 2018 09:24:42 +0100

orthanc-postgresql (2.2-3) unstable; urgency=medium

  * Fix build with PostgreSQL 11. Closes: #912108

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 28 Oct 2018 12:04:52 +0100

orthanc-postgresql (2.2-2) unstable; urgency=medium

  * Ignore loading of pg_trgm extension if insufficient privileges. Closes: #906771

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 03 Sep 2018 16:59:26 +0200

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Priority: optional
 Build-Depends: cmake,
                debhelper (>= 10),
+               libssl-dev,
                libboost-all-dev,
                libgtest-dev,
                libjsoncpp-dev,
@@ -12,8 +13,9 @@
                orthanc-dev,
                postgresql-server-dev-all,
                unzip,
-               uuid-dev
-Standards-Version: 4.1.5
+               uuid-dev,
+               zlib1g-dev
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-postgresql
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-postgresql.git
 Homepage: https://www.orthanc-server.com/static.php?page=postgresql

## orthanc-postgresql 3.2

=== PostgreSQL/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,17 @@
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPostgreSQL)
 
-set(ORTHANC_PLUGIN_VERSION "3.1")
+set(ORTHANC_PLUGIN_VERSION "3.2")
+
+set(ORTHANC_OPTIMAL_VERSION_MAJOR    1)
+set(ORTHANC_OPTIMAL_VERSION_MINOR    5)
+set(ORTHANC_OPTIMAL_VERSION_REVISION 4)
 
 if (ORTHANC_PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_VERSION "1.5.4")
+  set(ORTHANC_FRAMEWORK_VERSION "${ORTHANC_OPTIMAL_VERSION_MAJOR}.${ORTHANC_OPTIMAL_VERSION_MINOR}.${ORTHANC_OPTIMAL_VERSION_REVISION}")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()

=== debian/changelog ===
orthanc-postgresql (3.2-3) unstable; urgency=medium

  [ Dimitri John Ledkov and Gianfranco Costamagna ]
  * Fix FTBFS with PostgreSQL 12 and forthcoming 13. Closes: #966613

  [ Sebastien Jodogne ]
  * debhelper-compat 13

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 02 Aug 2020 11:10:59 +0200

orthanc-postgresql (3.2-2) unstable; urgency=medium

  * Updated Orthanc framework to 1.7.0. Closes: #962229

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 05 Jun 2020 08:59:16 +0200

orthanc-postgresql (3.2-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 01 Mar 2019 17:23:17 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 10),
+               debhelper-compat (= 13),
                libssl-dev,
                libboost-all-dev,
                libgtest-dev,
@@ -15,7 +15,7 @@
                unzip,
                uuid-dev,
                zlib1g-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-postgresql
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-postgresql.git
 Homepage: https://www.orthanc-server.com/static.php?page=postgresql

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk   # To access the "DEB_VERSION" variable

export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '-' -f 1)
export TARGET_INDEX := libOrthancPostgreSQLIndex.so
export TARGET_STORAGE := libOrthancPostgreSQLStorage.so

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# Disable assert() checking from upstream project, for best performance
# https://lists.debian.org/debian-med/2018/04/msg00132.html
export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ --builddirectory=Build

CMAKE_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DSTATIC_BUILD:BOOL=OFF \
	-DUSE_GOOGLE_TEST_DEBIAN_PACKAGE:BOOL=ON \
	-DORTHANC_FRAMEWORK_SOURCE=path \
	-DORTHANC_FRAMEWORK_ROOT=`pwd`/debian/orthanc-framework/Orthanc-1.7.0 \
	-DDEB_VERSION=$(DEB_VERSION) \
	-DCMAKE_BUILD_TYPE=None  # The build type must be set to None, see #711515

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=PostgreSQL -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_install:
	dh_install Build/${TARGET_INDEX}.${UPSTREAM_VERSION} usr/lib/orthanc
	dh_install Build/${TARGET_STORAGE}.${UPSTREAM_VERSION} usr/lib/orthanc

override_dh_link:
	dh_link usr/lib/orthanc/${TARGET_INDEX}.${UPSTREAM_VERSION} usr/share/orthanc/plugins/${TARGET_INDEX}
	dh_link usr/lib/orthanc/${TARGET_STORAGE}.${UPSTREAM_VERSION} usr/share/orthanc/plugins/${TARGET_STORAGE}

override_dh_installchangelogs:
	dh_installchangelogs -k PostgreSQL/NEWS

## orthanc-postgresql 3.3

=== PostgreSQL/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPostgreSQL)
 
-set(ORTHANC_PLUGIN_VERSION "3.2")
+set(ORTHANC_PLUGIN_VERSION "3.3")
 
 set(ORTHANC_OPTIMAL_VERSION_MAJOR    1)
 set(ORTHANC_OPTIMAL_VERSION_MINOR    5)
@@ -11,21 +11,23 @@
   set(ORTHANC_FRAMEWORK_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_VERSION "${ORTHANC_OPTIMAL_VERSION_MAJOR}.${ORTHANC_OPTIMAL_VERSION_MINOR}.${ORTHANC_OPTIMAL_VERSION_REVISION}")
+  set(ORTHANC_FRAMEWORK_VERSION "4a3ba4bf4ba7")  # This is Orthanc Framework pre-1.8.2 (includes a fix for OpenSSL on MSVC)
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
 
+set(ENABLE_SSL ON)
 include(${CMAKE_SOURCE_DIR}/../Resources/CMake/DatabasesPluginParameters.cmake)
 
 set(ENABLE_POSTGRESQL_BACKEND ON)
-  
+set(OPENSSL_STATIC_VERSION "1.1.1" CACHE STRING "Force the use of OpenSSL 1.1.1" FORCE)
+
 include(${CMAKE_SOURCE_DIR}/../Resources/CMake/DatabasesPluginConfiguration.cmake)
 
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
   execute_process(
     COMMAND 
-    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
+    ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
     ${ORTHANC_PLUGIN_VERSION} "PostgreSQL storage area plugin" OrthancPostgreSQLStorage.dll
     "PostgreSQL as a database back-end to Orthanc (storage area)"
     ERROR_VARIABLE Failure
@@ -38,7 +40,7 @@
 
   execute_process(
     COMMAND 
-    ${PYTHON_EXECUTABLE} ${ORTHANC_ROOT}/Resources/WindowsResources.py
+    ${PYTHON_EXECUTABLE} ${ORTHANC_FRAMEWORK_ROOT}/../Resources/WindowsResources.py
     ${ORTHANC_PLUGIN_VERSION} "PostgreSQL index plugin" OrthancPostgreSQLIndex.dll
     "PostgreSQL as a database back-end to Orthanc (index)"
     ERROR_VARIABLE Failure
@@ -62,6 +64,12 @@
   POSTGRESQL_GET_LAST_CHANGE_INDEX  ${CMAKE_SOURCE_DIR}/Plugins/GetLastChangeIndex.sql
   )
 
+add_custom_target(
+  AutogeneratedTarget
+  DEPENDS 
+  ${AUTOGENERATED_SOURCES}
+  )
+
 add_library(OrthancPostgreSQLIndex SHARED
   ${INDEX_RESOURCES}
   ${ORTHANC_DATABASES_ROOT}/Framework/Plugins/PluginInitialization.cpp
@@ -72,6 +80,8 @@
   ${AUTOGENERATED_SOURCES}
   )
 
+add_dependencies(OrthancPostgreSQLIndex AutogeneratedTarget)
+
 add_library(OrthancPostgreSQLStorage SHARED
   ${ORTHANC_DATABASES_ROOT}/Framework/Plugins/PluginInitialization.cpp
   ${STORAGE_RESOURCES}
@@ -81,6 +91,8 @@
   ${DATABASES_SOURCES}
   ${AUTOGENERATED_SOURCES}
   )
+
+add_dependencies(OrthancPostgreSQLStorage AutogeneratedTarget)
 
 message("Setting the version of the libraries to ${ORTHANC_PLUGIN_VERSION}")
 
@@ -117,6 +129,8 @@
   ${AUTOGENERATED_SOURCES}
   )
 
+add_dependencies(UnitTests AutogeneratedTarget)
+
 target_link_libraries(UnitTests ${GOOGLE_TEST_LIBRARIES})
 set_target_properties(UnitTests PROPERTIES
   COMPILE_FLAGS -DORTHANC_ENABLE_LOGGING_PLUGIN=0

=== debian/changelog ===
orthanc-postgresql (3.3-1) unstable; urgency=medium

  * New upstream version
  * Dynamic linking against "liborthancframework*"

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 14 Dec 2020 18:19:06 +0100

=== debian/control ===
--- 
+++ 
@@ -5,17 +5,13 @@
 Priority: optional
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               libssl-dev,
-               libboost-all-dev,
                libgtest-dev,
-               libjsoncpp-dev,
+               liborthancframework-dev,
                libpq-dev,
                orthanc-dev,
                postgresql-server-dev-all,
-               unzip,
-               uuid-dev,
-               zlib1g-dev
-Standards-Version: 4.5.0
+               unzip
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-postgresql
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-postgresql.git
 Homepage: https://www.orthanc-server.com/static.php?page=postgresql

=== debian/rules ===
--- 
+++ 
@@ -20,8 +20,7 @@
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
 	-DSTATIC_BUILD:BOOL=OFF \
 	-DUSE_GOOGLE_TEST_DEBIAN_PACKAGE:BOOL=ON \
-	-DORTHANC_FRAMEWORK_SOURCE=path \
-	-DORTHANC_FRAMEWORK_ROOT=`pwd`/debian/orthanc-framework/Orthanc-1.7.0 \
+	-DORTHANC_FRAMEWORK_SOURCE=system \
 	-DDEB_VERSION=$(DEB_VERSION) \
 	-DCMAKE_BUILD_TYPE=None  # The build type must be set to None, see #711515

=== debian/watch ===
version=3
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,downloadurlmangle=s/\/browse\.php\?path=//g,repack,compression=xz" \
https://www.orthanc-server.com/browse.php?path=/plugin-postgresql downloads/get\.php\?path=/plugin-postgresql/OrthancPostgreSQL-(\d\S*)\.tar\.gz

## orthanc-postgresql 4.0

=== PostgreSQL/CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,17 @@
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPostgreSQL)
 
-set(ORTHANC_PLUGIN_VERSION "3.3")
+set(ORTHANC_PLUGIN_VERSION "4.0")
 
 set(ORTHANC_OPTIMAL_VERSION_MAJOR    1)
-set(ORTHANC_OPTIMAL_VERSION_MINOR    5)
-set(ORTHANC_OPTIMAL_VERSION_REVISION 4)
+set(ORTHANC_OPTIMAL_VERSION_MINOR    9)
+set(ORTHANC_OPTIMAL_VERSION_REVISION 2)
 
 if (ORTHANC_PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_VERSION "4a3ba4bf4ba7")  # This is Orthanc Framework pre-1.8.2 (includes a fix for OpenSSL on MSVC)
+  set(ORTHANC_FRAMEWORK_VERSION "1.9.2")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()

=== debian/changelog ===
orthanc-postgresql (4.0-7) unstable; urgency=medium

  * Team Upload.
  * Fix FTBFS with postgres 15 (Closes: #1022408)

 -- Nilesh Patra <nilesh@debian.org>  Mon, 24 Oct 2022 07:55:03 +0000

orthanc-postgresql (4.0-6) unstable; urgency=medium

  * Rebuild because of fix in build dependencies.
  * Updated d/copyright

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 01 Jun 2022 07:29:11 +0200

orthanc-postgresql (4.0-5) unstable; urgency=medium

  * Replace explicit restart of Orthanc by orthanc-restart-trigger

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 16 Jan 2022 18:33:58 +0100

orthanc-postgresql (4.0-4) unstable; urgency=medium

  * Fix FTBFS with PostgreSQL 14. Closes: #997392

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 24 Oct 2021 10:31:29 +0200

orthanc-postgresql (4.0-3) unstable; urgency=medium

  * Upload to unstable after freeze

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 01 Sep 2021 15:09:07 +0200

orthanc-postgresql (4.0-2) experimental; urgency=medium

  * Added missing "Built-Using" attribute

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 08 Jul 2021 16:44:57 +0200

orthanc-postgresql (4.0-1) experimental; urgency=medium

  * New upstream version
  * Statically link against the Orthanc framework

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 26 Apr 2021 10:54:17 +0200

=== debian/control ===
--- 
+++ 
@@ -8,10 +8,11 @@
                libgtest-dev,
                liborthancframework-dev,
                libpq-dev,
-               orthanc-dev,
+               orthanc-dev (>= 0.9.5),
                postgresql-server-dev-all,
+               uuid-dev,
                unzip
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-postgresql
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-postgresql.git
 Homepage: https://www.orthanc-server.com/static.php?page=postgresql
@@ -20,7 +21,8 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         orthanc (>= 0.9.5)
+         orthanc (>= 1.9.7+dfsg-6)
+Built-Using: ${orthancframework:Built-Using}
 Suggests: postgresql
 Description: Plugins to use PostgreSQL as a database back-end to Orthanc
  Orthanc PostgreSQL is a set of two plugins to Orthanc, a lightweight,

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,17 @@
 	-DUSE_GOOGLE_TEST_DEBIAN_PACKAGE:BOOL=ON \
 	-DORTHANC_FRAMEWORK_SOURCE=system \
 	-DDEB_VERSION=$(DEB_VERSION) \
+	-DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
+	"-DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=boost_filesystem boost_iostreams boost_locale boost_regex boost_thread jsoncpp pugixml uuid" \
 	-DCMAKE_BUILD_TYPE=None  # The build type must be set to None, see #711515
+
+
+# Automated generation of the "Built-Using" attribute in "d/control"
+# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=989128
+# Adapted from:
+# https://wiki.debian.org/SIMDEverywhere#Approach (Point 6)
+override_dh_gencontrol:
+	dh_gencontrol -- -Vorthancframework:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W liborthancframework-dev)"
 
 override_dh_auto_configure:
 	dh_auto_configure --sourcedirectory=PostgreSQL -- $(CMAKE_EXTRA_FLAGS)

## orthanc-postgresql 5.0%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 include /usr/share/dpkg/pkg-info.mk   # To access the "DEB_VERSION" variable
 
-export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '-' -f 1)
+export UPSTREAM_VERSION := $(shell echo "$(DEB_VERSION)" | cut -d '+' -f 1)
 export TARGET_INDEX := libOrthancPostgreSQLIndex.so
 export TARGET_STORAGE := libOrthancPostgreSQLStorage.so

## orthanc-postgresql 5.0+dfsg

=== PostgreSQL/CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,37 @@
+# Orthanc - A Lightweight, RESTful DICOM Store
+# Copyright (C) 2012-2016 Sebastien Jodogne, Medical Physics
+# Department, University Hospital of Liege, Belgium
+# Copyright (C) 2017-2023 Osimis S.A., Belgium
+# Copyright (C) 2021-2023 Sebastien Jodogne, ICTEAM UCLouvain, Belgium
+#
+# This program is free software: you can redistribute it and/or
+# modify it under the terms of the GNU Affero General Public License
+# as published by the Free Software Foundation, either version 3 of
+# the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Affero General Public License for more details.
+# 
+# You should have received a copy of the GNU Affero General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+
 cmake_minimum_required(VERSION 2.8)
 project(OrthancPostgreSQL)
 
-set(ORTHANC_PLUGIN_VERSION "4.0")
+set(ORTHANC_PLUGIN_VERSION "5.0")
 
 set(ORTHANC_OPTIMAL_VERSION_MAJOR    1)
-set(ORTHANC_OPTIMAL_VERSION_MINOR    9)
-set(ORTHANC_OPTIMAL_VERSION_REVISION 2)
+set(ORTHANC_OPTIMAL_VERSION_MINOR    12)
+set(ORTHANC_OPTIMAL_VERSION_REVISION 0)
 
 if (ORTHANC_PLUGIN_VERSION STREQUAL "mainline")
   set(ORTHANC_FRAMEWORK_VERSION "mainline")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "hg")
 else()
-  set(ORTHANC_FRAMEWORK_VERSION "1.9.2")
+  set(ORTHANC_FRAMEWORK_VERSION "1.12.0")
   set(ORTHANC_FRAMEWORK_DEFAULT_SOURCE "web")
 endif()
 
@@ -19,7 +39,7 @@
 include(${CMAKE_SOURCE_DIR}/../Resources/CMake/DatabasesPluginParameters.cmake)
 
 set(ENABLE_POSTGRESQL_BACKEND ON)
-set(OPENSSL_STATIC_VERSION "1.1.1" CACHE STRING "Force the use of OpenSSL 1.1.1" FORCE)
+set(OPENSSL_STATIC_VERSION "3.0" CACHE STRING "Force the use of OpenSSL 3.0.x" FORCE)
 
 include(${CMAKE_SOURCE_DIR}/../Resources/CMake/DatabasesPluginConfiguration.cmake)
 
@@ -64,35 +84,58 @@
   POSTGRESQL_GET_LAST_CHANGE_INDEX  ${CMAKE_SOURCE_DIR}/Plugins/GetLastChangeIndex.sql
   )
 
+
+if (EXISTS ${ORTHANC_SDK_ROOT}/orthanc/OrthancDatabasePlugin.proto)
+  add_custom_command(
+    COMMAND
+    ${PROTOC_EXECUTABLE} ${ORTHANC_SDK_ROOT}/orthanc/OrthancDatabasePlugin.proto --cpp_out=${AUTOGENERATED_DIR} -I${ORTHANC_SDK_ROOT}/orthanc/
+    DEPENDS
+    ProtobufCompiler
+    ${ORTHANC_SDK_ROOT}/orthanc/OrthancDatabasePlugin.proto
+    OUTPUT
+    ${AUTOGENERATED_DIR}/OrthancDatabasePlugin.pb.cc
+    ${AUTOGENERATED_DIR}/OrthancDatabasePlugin.pb.h
+    )
+
+  list(APPEND AUTOGENERATED_SOURCES
+    ${AUTOGENERATED_DIR}/OrthancDatabasePlugin.pb.cc
+    )
+endif()
+
+
 add_custom_target(
   AutogeneratedTarget
   DEPENDS 
   ${AUTOGENERATED_SOURCES}
   )
 
+add_library(FrameworkForPlugins STATIC
+  ${AUTOGENERATED_SOURCES}
+  ${DATABASES_SOURCES}
+  ${ORTHANC_DATABASES_ROOT}/Framework/Plugins/PluginInitialization.cpp
+  Plugins/PostgreSQLIndex.cpp
+  Plugins/PostgreSQLStorageArea.cpp
+  )
+
+set_target_properties(FrameworkForPlugins PROPERTIES
+  POSITION_INDEPENDENT_CODE ON
+  COMPILE_FLAGS -DORTHANC_ENABLE_LOGGING_PLUGIN=1
+  )
+
 add_library(OrthancPostgreSQLIndex SHARED
   ${INDEX_RESOURCES}
-  ${ORTHANC_DATABASES_ROOT}/Framework/Plugins/PluginInitialization.cpp
   Plugins/IndexPlugin.cpp
-  Plugins/PostgreSQLIndex.cpp
-
-  ${DATABASES_SOURCES}
-  ${AUTOGENERATED_SOURCES}
   )
 
-add_dependencies(OrthancPostgreSQLIndex AutogeneratedTarget)
-
 add_library(OrthancPostgreSQLStorage SHARED
-  ${ORTHANC_DATABASES_ROOT}/Framework/Plugins/PluginInitialization.cpp
   ${STORAGE_RESOURCES}
-  Plugins/PostgreSQLStorageArea.cpp
   Plugins/StoragePlugin.cpp
-
-  ${DATABASES_SOURCES}
-  ${AUTOGENERATED_SOURCES}
   )
 
-add_dependencies(OrthancPostgreSQLStorage AutogeneratedTarget)
+add_dependencies(FrameworkForPlugins AutogeneratedTarget)
+
+target_link_libraries(OrthancPostgreSQLIndex FrameworkForPlugins)
+target_link_libraries(OrthancPostgreSQLStorage FrameworkForPlugins)
 
 message("Setting the version of the libraries to ${ORTHANC_PLUGIN_VERSION}")

=== debian/changelog ===
orthanc-postgresql (5.0+dfsg-5) unstable; urgency=medium

  * Fix FTBFS with recent versions of CMake (Closes: #1113375)

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 01 Sep 2025 12:17:15 +0200

orthanc-postgresql (5.0+dfsg-4) unstable; urgency=medium

  * Fix FTBFS with boost 1.88 (Closes: #1110760)

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 19 Aug 2025 13:52:47 +0200

orthanc-postgresql (5.0+dfsg-3) unstable; urgency=medium

  * Fix FTBFS with PostgreSQL 17

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 27 Sep 2024 10:22:49 +0200

orthanc-postgresql (5.0+dfsg-2) unstable; urgency=medium

  * Team Upload.
  * Fix FTBFS with postgres 16 (Closes: #1052893)

 -- Nilesh Patra <nilesh@debian.org>  Mon, 02 Oct 2023 13:59:01 +0530

orthanc-postgresql (5.0+dfsg-1) unstable; urgency=medium

  * New upstream version. Closes: #1037603

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sat, 15 Jul 2023 13:16:22 +0200

=== debian/control ===
--- 
+++ 
@@ -8,14 +8,17 @@
                libgtest-dev,
                liborthancframework-dev,
                libpq-dev,
+               libprotobuf-dev,
                orthanc-dev (>= 0.9.5),
                postgresql-server-dev-all,
+               protobuf-compiler,
                uuid-dev,
                unzip
-Standards-Version: 4.6.0
+Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/orthanc-postgresql
 Vcs-Git: https://salsa.debian.org/med-team/orthanc-postgresql.git
-Homepage: https://www.orthanc-server.com/static.php?page=postgresql
+Homepage: https://orthanc.uclouvain.be/book/plugins/postgresql.html
 
 Package: orthanc-postgresql
 Architecture: any

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
https://orthanc.uclouvain.be/downloads/sources/orthanc-postgresql/index.html OrthancPostgreSQL-(\d\S*)\.tar\.gz
